﻿using System;
using System.ServiceModel;
using System.Threading;
using System.Security.Permissions;
using System.Diagnostics;

namespace Host
{
    [ServiceBehavior(IncludeExceptionDetailInFaults = true)]
    public class Servico : IContrato
    {
        [PrincipalPermissionAttribute(SecurityAction.Demand, Role="Admin")]
        public string Metodo()
        {
            return string.Format(
                "Thread: {0} - Context.Primary: {1} - Context.Windows: {2}", 
                    Thread.CurrentPrincipal.Identity.Name, 
                    OperationContext.Current.ServiceSecurityContext.PrimaryIdentity.Name,
                    OperationContext.Current.ServiceSecurityContext.WindowsIdentity.Name);
        }
    }
}